/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.system.libraries;

import java.awt.Cursor;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.JComponent;
import javax.swing.JPopupMenu;
import javax.swing.ToolTipManager;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;
import org.visnow.vn.application.application.Application;
import org.visnow.vn.application.frames.tabs.ModuleAdder;
import org.visnow.vn.engine.library.LibraryCore;
import org.visnow.vn.lib.basic.mappers.Isosurface.IsosurfaceGUI;
import org.visnow.vn.lib.utils.SwingInstancer;
import org.visnow.vn.system.main.VisNow;
import org.visnow.vn.system.swing.LibTreeCellRenderer;

/**
 *
 * @author babor
 */
//public class NewModuleTreePanel extends javax.swing.JPanel {
public class NewModuleTreePanel extends javax.swing.JMenuItem
{

    private Point point = null;

    /**
     * Creates new form TreePanel
     */
    public NewModuleTreePanel(DefaultTreeModel model, final Point point, final JPopupMenu popup, final JComponent parentComponent)
    {
        initComponents();
        this.point = point;
        ToolTipManager.sharedInstance().registerComponent(tree);
        tree.setCellRenderer(new LibTreeCellRenderer());
        tree.setModel(model);
        tree.expandRow(0);
        if (tree.getRowCount() > 0)
            tree.expandRow(1);
        tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        tree.addMouseListener(new MouseListener()
        {
            @Override
            public void mouseClicked(MouseEvent e)
            {
                TreePath p = tree.getSelectionPath();
                if (p == null)
                    return;
                final DefaultMutableTreeNode tn = (DefaultMutableTreeNode) p.getLastPathComponent();
                if (tn == null)
                    return;
                if (e.getButton() == MouseEvent.BUTTON3 && tn.getUserObject() instanceof LibraryCore) {
                    VisNow.get().showHelp(((LibraryCore) (tn.getUserObject())).getHelpTopicID());
                    return;
                }
                if (e.getButton() == MouseEvent.BUTTON1 && e.getClickCount() == 2) {
                    if (tn.isLeaf() && tn.getUserObject() instanceof LibraryCore) {
                        popup.setVisible(false);
                        LibraryCore core = (LibraryCore) tn.getUserObject();
                        Application app = VisNow.get().getMainWindow().getApplicationsPanel().getCurrentApplication();
                        ModuleAdder.doAddModule(core, app, point, false);
                    }
                }
            }

            @Override
            public void mousePressed(MouseEvent e)
            {
            }

            @Override
            public void mouseReleased(MouseEvent e)
            {
            }

            @Override
            public void mouseEntered(MouseEvent e)
            {
            }

            @Override
            public void mouseExited(MouseEvent e)
            {
            }
        });
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        tree = new javax.swing.JTree();

        setMinimumSize(new java.awt.Dimension(260, 400));
        setPreferredSize(new java.awt.Dimension(260, 400));
        setLayout(new java.awt.BorderLayout());

        jScrollPane1.setViewportView(tree);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents
     // Variables declaration - do not modify//GEN-BEGIN:variables

    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTree tree;
    // End of variables declaration//GEN-END:variables
    /**
     * Utility field holding list of ChangeListeners.
     */
    protected transient ArrayList<ChangeListener> changeListenerList = new ArrayList<ChangeListener>();

    /**
     * Registers ChangeListener to receive events.
     * <p>
     * @param listener The listener to register.
     */
    @Override
    public synchronized void addChangeListener(ChangeListener listener)
    {
        changeListenerList.add(listener);
    }

    /**
     * Removes ChangeListener from the list of listeners.
     * <p>
     * @param listener The listener to remove.
     */
    @Override
    public synchronized void removeChangeListener(ChangeListener listener)
    {
        changeListenerList.remove(listener);
    }

    /**
     * Notifies all registered listeners about the event.
     *
     * @param object Parameter #1 of the <CODE>ChangeEvent<CODE> constructor.
     */
    @Override
    public void fireStateChanged()
    {
        ChangeEvent e = new ChangeEvent(this);
        for (int i = 0; i < changeListenerList.size(); i++) {
            changeListenerList.get(i).stateChanged(e);
        }
    }
}
